unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, QRExport, ImgList, ComCtrls, ToolWin, QRPrntr, DB, DBClient,
  ExtCtrls, QuickRpt, QRCtrls, StdCtrls;

type
  TPForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    QRPreview1: TQRPreview;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton_Separator1: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton_Separator2: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton_Separator3: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton_Separator4: TToolButton;
    ToolButton12: TToolButton;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    ImageList2: TImageList;
    QRCSVFilter1: TQRCSVFilter;
    QRTextFilter1: TQRTextFilter;
    QRHTMLFilter1: TQRHTMLFilter;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    ClientDataSet1: TClientDataSet;
    ClientDataSet1id: TStringField;
    ClientDataSet1name: TStringField;
    ClientDataSet1department: TStringField;
    Panel1: TPanel;
    Button1: TButton;
    QuickRep2: TQuickRep;
    QRBand2: TQRBand;
    QRLabel2: TQRLabel;
    QRBand4: TQRBand;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRGroup2: TQRGroup;
    QRLabel4: TQRLabel;
    QRBand6: TQRBand;
    QRBand7: TQRBand;
    QRLabel5: TQRLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure QRPreview1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure QRPreview1PageAvailable(Sender: TObject; PageNum: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure ToolButton12Click(Sender: TObject);
    Procedure SetStatusBarText();
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PForm1: TPForm1;

implementation

{$R *.dfm}

procedure TPForm1.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    Action := caFree;
    PForm1 := NIL;
end;

procedure TPForm1.QRPreview1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    IF Button = mbLeft THEN
        QRPreview1.Zoom := QRPreview1.Zoom + 5
    ELSE
        IF Button = mbRight THEN
            IF QRPreview1.Zoom > 50 THEN
                QRPreview1.Zoom := QRPreview1.Zoom - 5;
end;

procedure TPForm1.QRPreview1PageAvailable(Sender: TObject;
  PageNum: Integer);
begin
    SetStatusBarText;
end;

procedure TPForm1.ToolButton1Click(Sender: TObject);
begin
    QRPreview1.ZoomToFit;
end;

procedure TPForm1.ToolButton2Click(Sender: TObject);
begin
    QRPreview1.Zoom := 100;
end;

procedure TPForm1.ToolButton3Click(Sender: TObject);
begin
    QRPreview1.ZoomToWidth;
end;

procedure TPForm1.ToolButton4Click(Sender: TObject);
begin
    QRpreview1.PageNumber := 1;
    SetStatusBarText;
end;

procedure TPForm1.ToolButton5Click(Sender: TObject);
begin
    IF QRpreview1.PageNumber > 1 THEN
        QRpreview1.PageNumber := QRpreview1.PageNumber - 1;
    SetStatusBarText;
end;

procedure TPForm1.ToolButton6Click(Sender: TObject);
begin
    IF QRpreview1.QRPrinter.PageCount > QRpreview1.PageNumber THEN
        QRpreview1.PageNumber := QRpreview1.PageNumber + 1;
    SetStatusBarText;
end;

procedure TPForm1.ToolButton7Click(Sender: TObject);
begin
    QRpreview1.PageNumber := QRpreview1.QRPrinter.PageCount;
    SetStatusBarText;
end;

procedure TPForm1.ToolButton8Click(Sender: TObject);
begin
    QRPreview1.QRPrinter.PrintSetup;
end;

procedure TPForm1.ToolButton9Click(Sender: TObject);
begin
   QRPreview1.QRPrinter.Print;
end;

procedure TPForm1.ToolButton10Click(Sender: TObject);
var
    V_Save : BOOLEAN;
begin
    V_Save := False;
    IF SaveDialog1.Execute THEN
        IF FileExists(SaveDialog1.FileName) THEN
            BEGIN
                IF Application.MessageBox(PChar('ɮ ' + SaveDialog1.FileName + ' wsbAO_NH' ),'T{Nɮ',MB_ICONINFORMATION + MB_YESNO + MB_DEFBUTTON2) = IDYES then
                    V_Save := True
                ELSE
                    V_Save := False;
            END
        ELSE
            V_Save := True;
        IF V_Save THEN
            BEGIN
                IF UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.CSV' THEN
                    QRPreview1.QRPrinter.ExportToFilter(TQRCommaSeparatedFilter.Create(SaveDialog1.FileName))
                ELSE IF (UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.TXT') THEN
                    QRPreview1.QRPrinter.ExportToFilter(TQRAsciiExportFilter.Create(SaveDialog1.FileName))
                ELSE IF (UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.HTM') OR (UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.HTML') THEN
                    QRPreview1.QRPrinter.ExportToFilter(TQRHTMLDocumentFilter.Create(SaveDialog1.FileName))
                ELSE
                    QRPreview1.QRPrinter.Save(SaveDialog1.FileName);
            END;
{   HTML : TQRHTMLDocumentFilter
    ASCII : TQRAsciiExportFilter
    CSV : TQRCommaSeparatedFilter}
end;

procedure TPForm1.ToolButton11Click(Sender: TObject);
begin
    IF OpenDialog1.Execute THEN
        BEGIN
            QRPreview1.QRPrinter.Master := NIL;
            QRPreview1.QRPrinter.Load(OpenDialog1.Filename);
            QRPreview1.PageNumber := 1;
            QRPreview1.PreviewImage.PageNumber := 1;
            QRPreview1PageAvailable(NIL,1);
        END;
end;

procedure TPForm1.ToolButton12Click(Sender: TObject);
begin
    Close;
end;
procedure TPForm1.SetStatusBarText();
begin
    StatusBar1.SimpleText := ' ' + IntToStr(QRPreview1.PageNumber) + ' /@ ' + IntToStr(QRPreview1.QRPrinter.PageCount) + ' ';
  with QRPreview1 do
  begin
    ToolButton4.Enabled := PageNumber > 1;
    ToolButton5.Enabled := PageNumber > 1;
    ToolButton6.Enabled := PageNumber < QRPreview1.QRPrinter.PageCount;
    ToolButton7.Enabled := PageNumber < QRPreview1.QRPrinter.PageCount;
  end;
end;

procedure TPForm1.Button1Click(Sender: TObject);
var
  I : Integer;
begin
  ClientDataSet1.Close;
  ClientDataSet1.CreateDataSet;
  Randomize;
  for I := 1 to 100 do
    begin
      with ClientDataSet1 do
        begin
          Append;
          FieldByName('id').AsString := FormatFloat('00000',I);
          FieldByName('name').AsString := 'Name' + FormatFloat('00000',I);
          FieldByName('department').AsString := FormatFloat('00000',Random(10));
          Post;
        end;
    end;
    QuickRep2.Prepare;
    QRPreview1.QRPrinter := QuickRep2.QRPrinter;
    QRPreview1.ZoomToFit;
end;

end.
